# remirepo/Fedora spec file for php-zendframework-zend-file
#
# Copyright (c) 2015-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    b6e167e056ce8594be1db93460cddb503de341ed
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-file
%global php_home     %{_datadir}/php
%global library      File
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.8.3
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-fileinfo
BuildRequires:  php-hash
BuildRequires:  php-pcre
BuildRequires:  php-spl
BuildRequires:  php-tokenizer
BuildRequires:  php-composer(%{gh_owner}/zend-stdlib)           >= 2.7.7
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.2",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-filter": "^2.7.2",
#        "zendframework/zend-i18n": "^2.7.4",
#        "zendframework/zend-progressbar": "^2.5.2",
#        "zendframework/zend-servicemanager": "^2.7.8 || ^3.3",
#        "zendframework/zend-session": "^2.8",
#        "zendframework/zend-validator": "^2.10.1"
BuildRequires:  php-composer(phpunit/phpunit)                   >= 5.7
BuildRequires:  php-composer(%{gh_owner}/zend-filter)           >= 2.7.2
BuildRequires:  php-composer(%{gh_owner}/zend-i18n)             >= 2.7.4
BuildRequires:  php-composer(%{gh_owner}/zend-progressbar)      >= 2.5.2
BuildRequires:  php-composer(%{gh_owner}/zend-servicemanager)   >= 2.7.8
BuildRequires:  php-composer(%{gh_owner}/zend-session)          >= 2.8
BuildRequires:  php-composer(%{gh_owner}/zend-validator)        >= 2.10.1
# Autoloader
BuildRequires:  php-composer(%{gh_owner}/zend-loader)           >= 2.5
%endif

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-stdlib": "^2.7.7 || ^3.1"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
Requires:       php-composer(%{gh_owner}/zend-stdlib)           <  4
Requires:       php-composer(%{gh_owner}/zend-stdlib)           >= 2.7.7
# From composer, "suggest": {
#        "zendframework/zend-filter": "Zend\\Filter component",
#        "zendframework/zend-i18n": "Zend\\I18n component",
#        "zendframework/zend-validator": "Zend\\Validator component"
%if 0%{?fedora} >= 21
Suggests:       php-composer(%{gh_owner}/zend-filter)
Suggests:       php-composer(%{gh_owner}/zend-i18n)
Suggests:       php-composer(%{gh_owner}/zend-validator)
%endif
%endif
# From phpcompatinfo report for version 2.6.0
Requires:       php-fileinfo
Requires:       php-hash
Requires:       php-pcre
Requires:       php-reflection
Requires:       php-spl
Requires:       php-tokenizer

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}


%description
Zend\File is a component used to manage file transfer and class autoloading.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
# Empty build section, nothing required


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{php_home}/Zend/Loader/AutoloaderFactory.php';
Zend\Loader\AutoloaderFactory::factory(array(
    'Zend\Loader\StandardAutoloader' => array(
        'namespaces' => array(
           'ZendTest\\%{library}' => dirname(__DIR__).'/test/',
           'Zend\\%{library}'     => '%{buildroot}%{php_home}/Zend/%{library}'
))));
require_once '%{php_home}/Zend/autoload.php';
EOF

ret=0
for cmd in php php56 php70 php71 php72 php73; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}


%changelog
* Thu Feb  7 2019 Remi Collet <remi@remirepo.net> - 2.8.3-1
- update to 2.8.3 (no change)

* Mon Oct 15 2018 Remi Collet <remi@remirepo.net> - 2.8.2-1
- update to 2.8.2

* Wed May  2 2018 Remi Collet <remi@remirepo.net> - 2.8.1-1
- update to 2.8.1

* Thu Apr 26 2018 Remi Collet <remi@remirepo.net> - 2.8.0-1
- update to 2.8.0
- raise dependency on PHP 5.6
- raise dependency on zend-stdlib 2.7.7

* Wed Jan 11 2017 Remi Collet <remi@fedoraproject.org> - 2.7.1-1
- update to 2.7.1

* Fri Apr 29 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- update to 2.7.0

* Thu Mar  3 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- update to 2.6.1

* Thu Feb 18 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- update to 2.6.0
- raise dependency on zend-stdlib >= 2.7

* Wed Feb 17 2016 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- update to 2.5.2
- raise dependency on PHP >= 5.5

* Sun Feb 14 2016 Remi Collet <remi@fedoraproject.org> - 2.5.1-3
- add patch for newer zend-filter

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
